import 'dart:ffi';

import 'package:plugin_platform_interface/plugin_platform_interface.dart';

import 'classify_photo_method_channel.dart';

abstract class ClassifyPhotoPlatform extends PlatformInterface {
  /// Constructs a ClassifyPhotoPlatform.
  ClassifyPhotoPlatform() : super(token: _token);

  static final Object _token = Object();

  static ClassifyPhotoPlatform _instance = MethodChannelClassifyPhoto();

  /// The default instance of [ClassifyPhotoPlatform] to use.
  ///
  /// Defaults to [MethodChannelClassifyPhoto].
  static ClassifyPhotoPlatform get instance => _instance;

  /// Platform-specific implementations should set this with their own
  /// platform-specific class that extends [ClassifyPhotoPlatform] when
  /// they register themselves.
  static set instance(ClassifyPhotoPlatform instance) {
    PlatformInterface.verifyToken(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('platformVersion() has not been implemented.');
  }

  Future<List<Map<String, dynamic>>?> getPhoto() {
    throw UnimplementedError('getPhoto() has not been implemented.');
  }

  // 添加获取存储信息的方法
  Future<Map<String, int>> getStorageInfo() {
    throw UnimplementedError('getStorageInfo() has not been implemented.');
  }

  // 检查是否试用
  Future<bool> checkTrialEligibility(String appleId) {
    throw UnimplementedError('checkTrialEligibility() has not been implemented.');
  }

  /// 获取照片 EXIF 信息
  Future<Map<String, dynamic>> getPhotoExif(String filePath) {
    throw UnimplementedError('getPhotoExif() has not been implemented.');
  }

  Future<void> finishTransaction() {
    throw UnimplementedError('finishTransaction() has not been implemented.');
  }

  Future<int> calculatePhotoSize(List<String> assetIds) {
    throw UnimplementedError('finishTransaction() has not been implemented.');
  }
}
